
//	dm.h

#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include <math.h>

#define SMAX	((1<<15)-1)	// MAX in short
#define SMIN	(-(1<<15))	// MIN in short
#define CH	2		// # of channels
#define LL	14		// buffer log len
#define BLL	(LL-2)		// block log len
#define L	(1<<LL)		// buffer length
#define L1	(L-1)		// buffer length-1
#define BL	(1<<BLL)	// block length
#define LEAK	16		// in/out LEAK 16..64
#define MINQ	8		// 64k-22k:8,  16:lower
#define MAXQ	MINQ*4095	// 12 bits quant
#define QV	4096		// Quant Value in qm
#define QVC	(QV/4)		// (QV/2, QV/4) for lowest freq
#define QM	1		// high freq q-mul (4:Pops, 2:Classic)
#define HTL	256		// Huffman Table Length
#define M	3		// 1:no div, max:8,5(DCT,DFT,TFT)4096-256
#define AL	(BL>>(M-1))	// BL/AL: frame div rate
#define C	(L/AL)		// analizing table len
#define C1	(C-1)
#define BR	64		// def. bitrate [Kbps for stereo]
#define AT	4		// average power rate to divide frame
#define Pred			// fmdct prediction

//#define HT	// make Huffman Table
typedef unsigned int Ui;
void init_ct(), fmdct(), imdct();
extern int run[HTL], level[HTL], cod[HTL], len[HTL], qm[BL];
extern int eob, esc, prp, ms, gmin[2], audio;
extern FILE *outfp;
void aopen(), awrite(), aclose();
